
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class NotificationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notifications = await db.notifications.create(
            {
                id: data.id || undefined,
        
        notification_type: data.notification_type
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        message: data.message
        ||
        null
            ,
            
        is_read: data.is_read
        ||
        false
        
            ,
            
        read_at: data.read_at
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
        priority: data.priority
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await notifications.setRecipient( data.recipient || null, {
            transaction,
        });
        
        await notifications.setAnnouncement( data.announcement || null, {
            transaction,
        });
        
        await notifications.setHomework( data.homework || null, {
            transaction,
        });
        
        await notifications.setSubmission( data.submission || null, {
            transaction,
        });
        
        await notifications.setSent_by( data.sent_by || null, {
            transaction,
        });
        
        await notifications.setSchools( data.schools || null, {
            transaction,
        });
        

        

        

        return notifications;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const notificationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                notification_type: item.notification_type
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                message: item.message
            ||
            null
            ,
            
                is_read: item.is_read
            ||
            false
        
            ,
            
                read_at: item.read_at
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
                priority: item.priority
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const notifications = await db.notifications.bulkCreate(notificationsData, { transaction });

        // For each item created, replace relation files
        

        return notifications;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const notifications = await db.notifications.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.notification_type !== undefined) updatePayload.notification_type = data.notification_type;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.message !== undefined) updatePayload.message = data.message;
        
        
        if (data.is_read !== undefined) updatePayload.is_read = data.is_read;
        
        
        if (data.read_at !== undefined) updatePayload.read_at = data.read_at;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        if (data.priority !== undefined) updatePayload.priority = data.priority;
        
        
        updatePayload.updatedById = currentUser.id;

        await notifications.update(updatePayload, {transaction});

        
        
        if (data.recipient !== undefined) {
            await notifications.setRecipient(
              
              data.recipient,
              
              { transaction }
            );
        }
        
        if (data.announcement !== undefined) {
            await notifications.setAnnouncement(
              
              data.announcement,
              
              { transaction }
            );
        }
        
        if (data.homework !== undefined) {
            await notifications.setHomework(
              
              data.homework,
              
              { transaction }
            );
        }
        
        if (data.submission !== undefined) {
            await notifications.setSubmission(
              
              data.submission,
              
              { transaction }
            );
        }
        
        if (data.sent_by !== undefined) {
            await notifications.setSent_by(
              
              data.sent_by,
              
              { transaction }
            );
        }
        
        if (data.schools !== undefined) {
            await notifications.setSchools(
              
              data.schools,
              
              { transaction }
            );
        }
        

        
        

        

        return notifications;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notifications = await db.notifications.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of notifications) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of notifications) {
                await record.destroy({transaction});
            }
        });


        return notifications;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const notifications = await db.notifications.findByPk(id, options);

        await notifications.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await notifications.destroy({
            transaction
        });

        return notifications;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const notifications = await db.notifications.findOne(
            { where },
            { transaction },
        );

        if (!notifications) {
            return notifications;
        }

        const output = notifications.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.recipient = await notifications.getRecipient({
            transaction
        });
        
        
        output.announcement = await notifications.getAnnouncement({
            transaction
        });
        
        
        output.homework = await notifications.getHomework({
            transaction
        });
        
        
        output.submission = await notifications.getSubmission({
            transaction
        });
        
        
        output.sent_by = await notifications.getSent_by({
            transaction
        });
        
        
        output.schools = await notifications.getSchools({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userSchools = (user && user.schools?.id) || null;
        

        
        if (userSchools) {
            if (options?.currentUser?.schoolsId) {
                where.schoolsId = options.currentUser.schoolsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'recipient',
        
        where: filter.recipient ? {
          [Op.or]: [
            { id: { [Op.in]: filter.recipient.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.recipient.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.announcements,
        as: 'announcement',
        
        where: filter.announcement ? {
          [Op.or]: [
            { id: { [Op.in]: filter.announcement.split('|').map(term => Utils.uuid(term)) } },
            {
              announcement_title: {
                [Op.or]: filter.announcement.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.homeworks,
        as: 'homework',
        
        where: filter.homework ? {
          [Op.or]: [
            { id: { [Op.in]: filter.homework.split('|').map(term => Utils.uuid(term)) } },
            {
              homework_title: {
                [Op.or]: filter.homework.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.homework_submissions,
        as: 'submission',
        
        where: filter.submission ? {
          [Op.or]: [
            { id: { [Op.in]: filter.submission.split('|').map(term => Utils.uuid(term)) } },
            {
              submission_status: {
                [Op.or]: filter.submission.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'sent_by',
        
        where: filter.sent_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sent_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.sent_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.schools,
        as: 'schools',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notifications',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notifications',
                        'message',
                        filter.message,
                    ),
                };
            }
            

            
            

            
            if (filter.read_atRange) {
                const [start, end] = filter.read_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    read_at: {
                    ...where.read_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    read_at: {
                    ...where.read_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.notification_type) {
                where = {
                    ...where,
                notification_type: filter.notification_type,
            };
            }
            
            if (filter.is_read) {
                where = {
                    ...where,
                is_read: filter.is_read,
            };
            }
            
            if (filter.priority) {
                where = {
                    ...where,
                priority: filter.priority,
            };
            }
            


      

      

      

      

      

      
      if (filter.schools) {
        const listItems = filter.schools.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          schoolsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.schoolsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.notifications.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'notifications',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.notifications.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

